#pragma once
#include <string>
#include "koopa.h"

/*
访问 raw program
typedef struct {
  /// Global values (global allocations only).
  koopa_raw_slice_t values;
  /// Function definitions.
  koopa_raw_slice_t funcs;
} koopa_raw_program_t;
*/
void Visit(const koopa_raw_program_t &program);

/*
typedef struct {
  /// Buffer of slice items.
  const void **buffer;
  /// Length of slice.
  uint32_t len;
  /// Kind of slice items.
  koopa_raw_slice_item_kind_t kind;
} koopa_raw_slice_t;
访问slice
*/
void Visit(const koopa_raw_slice_t &slice);

/*
访问函数
typedef struct {
  /// Type of function.
  koopa_raw_type_t ty;
  /// Name of function.
  const char *name;
  /// Parameters.
  koopa_raw_slice_t params;
  /// Basic blocks, empty if is a function declaration.
  koopa_raw_slice_t bbs;
} koopa_raw_function_data_t;
///
/// A raw Koopa function.
///
typedef const koopa_raw_function_data_t *koopa_raw_function_t;
*/
void Visit(const koopa_raw_function_t &func);

/*
访问基本块
typedef struct {
  /// Name of basic block, null if no name.
  const char *name;
  /// Parameters.
  koopa_raw_slice_t params;
  /// Values that this basic block is used by.
  koopa_raw_slice_t used_by;
  /// Instructions in this basic block.
  koopa_raw_slice_t insts;
} koopa_raw_basic_block_data_t;
*/
void Visit(const koopa_raw_basic_block_t &bb);

/*
// 访问指令
struct koopa_raw_value_data {
  /// Type of value.
  koopa_raw_type_t ty;
  /// Name of value, null if no name.
  const char *name;
  /// Values that this value is used by.
  koopa_raw_slice_t used_by;
  /// Kind of value.
  koopa_raw_value_kind_t kind;
};
*/
void Visit(const koopa_raw_value_t &value);

// ret指令
void Visit(const koopa_raw_return_t &ret);

// integer
void Visit(const koopa_raw_integer_t &integer);

// binary 指令
void Visit(const koopa_raw_binary_t &binary, const koopa_raw_value_t &value);

// load
void Visit(const koopa_raw_load_t &load, const koopa_raw_value_t &value);

// store
void Visit(const koopa_raw_store_t &store);

// alloc
void Visit(const std::string &alloc, const koopa_raw_value_t &value);

// branch
void Visit(const koopa_raw_branch_t &branch, const koopa_raw_value_t &value);
// jump
void Visit(const koopa_raw_jump_t &jump);